#ifndef DWORD
typedef unsigned char      BYTE;
typedef unsigned short     WORD;
#ifdef __arch64__
typedef unsigned int       DWORD;
typedef unsigned long      QWORD;
#else
#ifdef __x86_64__
typedef unsigned int       DWORD;
typedef unsigned long      QWORD;
#else
typedef unsigned long      DWORD;
//typedef unsigned long long QWORD;
#if defined (__unix__)
typedef unsigned long long int 		QWORD;
#elif (defined (__MC68K__))	//Palm OS Motarolla 68k Compiller
typedef unsigned long QWORD;
#else
typedef unsigned __int64	QWORD;
#endif
#endif
#endif
typedef          short int SINT;
typedef          long  int LINT;
#endif

//   WS -       .
//              4 .
//   NK -       4- .
//   NQ -   Q  34.10-1994    WS.
//   NP -    P  34.10-1994    WS.
// CuNQ -   Q  34.10-2001    WS.
// CuNP -    P  34.10-2001    WS.
//        ,    P  Q,   
//          .

#define   LWS   4
#define   LNK   8
#define   LNQ   8
#define   LNP  64
#define LCuNQ   8
#define LCuNP   8

#include "CrC_Kernel.h"

#ifndef NULL
#define NULL 0
#endif

/**************************************************************BEG*/
#define RET_OK                0
#define RET_CONTEXTNOTCLEAR   1
#define RET_CONTEXTNOTREADY   2
#define RET_KEYNOTPRESENT     3
#define RET_KEYALREADYPRESENT 4
#define RET_INCORRECTSIGN     5
#define RET_ZERO_R            6
#define RET_ZERO_S            7
#define RET_BAD_R             8
#define RET_BAD_S             9
#define RET_FILE_OPEN        10
#define RET_FILE_SEEK        11
#define RET_FILE_READ        12
#define RET_FILE_CLOSE       13
#define RET_INCORRECTCONTEXT 14
#define RET_INVALIDPARAMETER 15
#define RET_INCORRECTSIZE    16

#define GOST_XXXXX_Marker_Mask        0xFFFFFFF0
#define R34_11_1994_Marker            0x9ABCDEF4
#define R34_10_2001_Marker            0x9ABCDEF7

/*****34-10**************************************BEG*/
#define R34_10_2001_CONTEXT    1
#define R34_10_2001_SECRETKEY  2
#define R34_10_2001_PUBLICKEY  4

/**********************************************************BEG*/
/**34-11******************************************************************/
/* -.......................................................*/
struct R34_11_1994
       {
       DWORD  Mark         ;                      /* Context Marker.          */
        BYTE  Feed  [LNQ*4];                      /*   .    */
        BYTE  Digest[LNQ*4];                      /*  -.      */
        BYTE  SumVec[LNQ*4];                      /*   .    */
         int  MsgLength    ;                      /*   . */
         int  BlockOffs    ;                      /* .   .   */
         int  IsReady      ;                      /*  ...Init().     */
       struct RND_State *RS;                      /*  .           */
       struct COM_State *PE;                      /* .             */
       };
/**34-10******************************************************************/
/*/    34-10-2001.......................*/
/* - PG_     Montgomery Domain  mod P  -   */
/*    P_SIZE*8:            [X]P = MontMult(X,PG_)(mod P).                */
struct LR34_10_2001
       {
       DWORD  Mark              ;  		  /* Context Marker.          */
       DWORD  SecretKey[LCuNQ*2];                 /* . .  .*/
struct LPoint PublicKey         ;                 /* .        .*/
       DWORD  a_       [LCuNP  ];                 /*  a . (HBO) */
       DWORD  b_       [LCuNP  ];                 /*  b . (HBO) */
       DWORD  P_       [LCuNP+1];                 /*       P.    (HBO) */
       DWORD  PG_      [LCuNP  ];                 /* 2^(2nP)(mod P).    (HBO) */
       DWORD  Q_       [LCuNQ+1];                 /*       Q.    (HBO) */
       DWORD  QG_      [LCuNQ  ];                 /* 2^(2nQ)(mod Q).    (HBO) */
       DWORD  QP_      [LCuNP+1];                 /*  Q  CuNP.    */
       DWORD  OQ_      [LCuNQ  ];                 /* [1]Q  CuNQ.   (HBO) */
       DWORD  OP_      [LCuNP  ];                 /* [1]P  CuNP.   (HBO) */
       DWORD  OQP_     [LCuNP  ];                 /* [1]Q  CuNP.   (HBO) */
struct LPoint A_                ;                 /*  A .    (HBO) */
struct LPoint AP_               ;                 /*  [A_]P. (HBO) */
       DWORD  Half     [LCuNP  ];                 /* [1/2]P.            (HBO) */
         int  P_Size            ;                 /*   P (). */
         int  Q_Size            ;                 /*   Q (). */
         int  IsReady           ;                 /*  .     */
       struct RND_State *RS     ;                 /*  .           */
       };
/**********************************************************END*/

/******************************************BEG*/

/******************************************************************************/
/*.34-11.................................................................*/
/******************************************************************************/
/******************************************************************************/
/*.-.......................................................*/
/******************************************************************************/

int CrypC_R34_11_1994_init(struct R34_11_1994 *Context, struct COM_State *PE, struct RND_State *State, void *Sync);
/******************************************************************************/
/*                                                      */
/*                          -                              */
/******************************************************************************/
/*  :                                                         */
/* -    : *Context ().                      */
/* -      - *Sync (NQ*2 ).   */
/*                0,    .     */
/* :                                                                     */
/* - ,    -.                               */
/*  :                                                             */
/* - RET_OK                                                                   */
/* - RET_INCORRECTCONTEXT  -    . .  */
/* - RET_CONTEXTNOTCLEAR                                                      */
/* - RET_INVALIDPARAMETER  -     .      */
/******************************************************************************/

int CrypC_R34_11_1994_update(struct R34_11_1994 *Context, void *Buff, LINT LenBuff);
/******************************************************************************/
/*            -              */
/******************************************************************************/
/*  :                                                         */
/* -    : *Context ().                      */
/* -       *Buff.                         */
/* -     *Buf   LenBuff.                             */
/* :                                                                     */
/* -   .                                    */
/*  :                                                             */
/* - RET_OK                                                                   */
/* - RET_CONTEXTNOTREADY                                                      */
/* - RET_INVALIDPARAMETER  -     .      */
/******************************************************************************/

int CrypC_R34_11_1994_final(struct R34_11_1994 *Context, void *Digest);
/******************************************************************************/
/*                          */
/*                                                         */
/******************************************************************************/
/*  :                                                         */
/* -    : *Context ().                      */
/* -      - *Digest.                     */
/* :                                                                     */
/* -   -  - .                */
/*  :                                                             */
/* - RET_OK                                                                   */
/* - RET_CONTEXTNOTREADY                                                      */
/* - RET_INVALIDPARAMETER  -     .      */
/******************************************************************************/

int CrypC_R34_11_1994_clear(struct R34_11_1994 *Context);
/******************************************************************************/
/*                                                            */
/*                          -                              */
/******************************************************************************/
/*  :                                                         */
/* -    : *Context ().                      */
/* :                                                                     */
/* -   .                                               */
/*  :                                                             */
/* - RET_OK                                                                   */
/* - RET_INCORRECTCONTEXT  -    . .  */
/* - RET_INVALIDPARAMETER  -     .      */
/******************************************************************************/

/******************************************************************************/
/*.34-10.................................................................*/
/******************************************************************************/
/******************************************************************************/
/*/  .........................................*/
/******************************************************************************/

int CrypC_LR34_10_2001_set_parms(struct   LR34_10_2001 *Context,
                                 struct   RND_State  *State,
                                 void   *_R34_10_2001_P, int P_Size,
                                 void   *_R34_10_2001_Q, int Q_Size,
                                 void   *_R34_10_2001_a,
                                 void   *_R34_10_2001_b,
                          struct LPoint * R34_10_2001_A
                                );
/******************************************************************************/
/*                                          */
/*               /                   */
/*                     ("" )                            */
/*                             3410-2001                                 */
/******************************************************************************/
/*  :                                                         */
/* -    : *Context ().                      */
/* -     P_Size     P: *GOST_C3411_P.     */
/* -     Q_Size     Q: *R34_10_2001_Q.    */
/* -     *P_Size   a : *R34_10_2001_a.    */
/* -     *P_Size   b : *R34_10_2001_b.    */
/* -               A : *R34_10_2001_A.    */
/*    -   0,         */
/*     P_Size     .      */
/*    .                                                  */
/* :                                                                     */
/* - ,     /   .  */
/*  :                                                             */
/* - RET_OK                -  .                           */
/* - RET_INCORRECTCONTEXT  -    . .  */
/* - RET_CONTEXTNOTCLEAR   -   .                  */
/* - RET_INVALIDPARAMETER  -     .      */
/******************************************************************************/

int CrypC_LR34_10_2001_gen_secret_key(struct LR34_10_2001 *Context);
/******************************************************************************/
/*                                */
/*                                           */
/******************************************************************************/
/*  :                                                         */
/* -    : *Context ().                      */
/* :                                                                     */
/* - ,     .                         */
/*  :                                                             */
/* - RET_OK                -  .                           */
/* - RET_CONTEXTNOREADY    -    .           */
/* - RET_KEYALREADYPRESENT -    .                   */
/* - RET_INVALIDPARAMETER  -     .      */
/******************************************************************************/

int CrypC_LR34_10_2001_gen_public_key(struct LR34_10_2001 *Context);
/******************************************************************************/
/*                                          */
/*                                           */
/*                                               */
/******************************************************************************/
/*  :                                                         */
/* -    : *Context ().                      */
/* :                                                                     */
/* - ,       .              */
/*  :                                                             */
/* - RET_OK                -  .                           */
/* - RET_CONTEXTNOREADY    -    .           */
/* - RET_KEYALREADYPRESENT -    .                    */
/* - RET_KEYNOTPRESENT     -    .                    */
/* - RET_INVALIDPARAMETER  -     .      */
/******************************************************************************/

int CrypC_LR34_10_2001_get_secret_key(struct LR34_10_2001 *Context, void *SecretKey, int *KeySize);
/******************************************************************************/
/*                    */
/******************************************************************************/
/*  :                                                         */
/* -    : *Context ().                      */
/* -      : *SecretKey.        */
/* -     : *KeySize.                              */
/* :                                                                     */
/* -      SecretKey,     */
/*   -   KeySize.                                                      */
/*    SecretKey == 0,     .                 */
/*  :                                                             */
/* - RET_OK                -  .                           */
/* - RET_CONTEXTNOREADY    -    .           */
/* - RET_KEYNOTPRESENT     -    .                    */
/* - RET_INVALIDPARAMETER  -     .      */
/******************************************************************************/

int CrypC_LR34_10_2001_get_public_key(struct LR34_10_2001 *Context, struct LPoint *PublicKey, int *KeySize);
/******************************************************************************/
/*                     */
/******************************************************************************/
/*  :                                                         */
/* -    : *Context ().                      */
/* -     : *PublicKey.                          */
/* -     : *KeySize.                              */
/* :                                                                     */
/* -     PublicKey,     -         */
/*   KeySize (      -  C3410).           */
/*    PublicKey == 0,     .                 */
/*  :                                                             */
/* - RET_OK                -  .                           */
/* - RET_CONTEXTNOREADY    -    .           */
/* - RET_KEYNOTPRESENT     -    .                     */
/* - RET_INVALIDPARAMETER  -     .      */
/******************************************************************************/

int CrypC_LR34_10_2001_set_secret_key(struct LR34_10_2001 *Context, void *SecretKey);
/******************************************************************************/
/*                   */
/******************************************************************************/
/*  :                                                         */
/* -    : *Context ().                      */
/* -      : *SecretKey.        */
/* :                                                                     */
/* - ,     .                         */
/*  :                                                             */
/* - RET_OK                -  .                           */
/* - RET_CONTEXTNOREADY    -    .           */
/* - RET_KEYALREADYPRESENT -    .                   */
/* - RET_INVALIDPARAMETER  -     .      */
/******************************************************************************/

int CrypC_LR34_10_2001_set_public_key(struct LR34_10_2001 *Context, void *PublicKey);
/******************************************************************************/
/*                    */
/******************************************************************************/
/*  :                                                         */
/* -    : *Context ().                      */
/* -     : *PublicKey.                          */
/* :                                                                     */
/* - ,     .                           */
/*  :                                                             */
/* - RET_OK                -  .                           */
/* - RET_CONTEXTNOREADY    -    .           */
/* - RET_KEYALREADYPRESENT -    .                    */
/* - RET_INVALIDPARAMETER  -     .      */
/******************************************************************************/

int CrypC_LR34_10_2001_sign(struct LR34_10_2001 *Context, void *Digest, void *Signature);
/******************************************************************************/
/*               -                 */
/******************************************************************************/
/*  :                                                         */
/* -    : *Context ().                      */
/* -    -: Digest (NQ*2 ).                      */
/* -      : Signature (4*NQ ).          */
/* :                                                                     */
/* -      -.                      */
/*  :                                                             */
/* - RET_OK                -  .                           */
/* - RET_CONTEXTNOREADY    -    .           */
/* - RET_KEYNOTPRESENT     -    .                    */
/* - RET_INVALIDPARAMETER  -     .      */
/******************************************************************************/

int CrypC_LR34_10_2001_verify(struct LR34_10_2001 *Context, void *Digest, void *Signature);
/******************************************************************************/
/*                -                 */
/******************************************************************************/
/*  :                                                         */
/* -    : *Context ().                      */
/* -    -: Digest (NQ*2 ).                      */
/* -     : Signature (4*NQ ).              */
/* :                                                                     */
/* -  .                                                            */
/*  :                                                             */
/* - RET_OK             -  ,   .*/
/* - RET_INCORRECTSIGN  -  ,   .*/
/* - RET_ZERO_R         -     r'.                 */
/* - RET_ZERO_S         -     s .                 */
/* - RET_BAD_R          -     r'.            */
/* - RET_BAD_S          -     s .            */
/* - RET_CONTEXTNOTREADY   -    .           */
/* - RET_KEYNOTPRESENT     -    .                     */
/* - RET_INVALIDPARAMETER  -     .      */
/******************************************************************************/

int CrypC_LR34_10_2001_clear_secret_key(struct LR34_10_2001 *Context);
/******************************************************************************/
/*                                            */
/*                  /                         */
/******************************************************************************/
/*  :                                                         */
/* -    : *Context ().                      */
/* :                                                                     */
/* -      .                            */
/*  :                                                             */
/* - RET_OK                -  .                           */
/* - RET_INVALIDPARAMETER  -     .      */
/******************************************************************************/

int CrypC_LR34_10_2001_clear_public_key(struct LR34_10_2001 *Context);
/******************************************************************************/
/*                                             */
/*                  /                         */
/******************************************************************************/
/*  :                                                         */
/* -    : *Context ().                      */
/* :                                                                     */
/* -      .                             */
/*  :                                                             */
/* - RET_OK                -  .                           */
/* - RET_INVALIDPARAMETER  -     .      */
/******************************************************************************/

int CrypC_LR34_10_2001_clear(struct LR34_10_2001 *Context);
/******************************************************************************/
/*                                                            */
/*                  /                         */
/******************************************************************************/
/*  :                                                         */
/* -    : *Context ().                      */
/* :                                                                     */
/* -   .                                               */
/*  :                                                             */
/* - RET_OK                -  .                           */
/* - RET_INCORRECTCONTEXT  -    . .  */
/* - RET_INVALIDPARAMETER  -     .      */
/******************************************************************************/

int CrypC_LR34_10_2001_gen_mutual_key(struct LR34_10_2001 *Context,
                                       struct LPoint *PublicKey,
				       struct LPoint *MutualKey);
/******************************************************************************/
/*                                     */
/*            ,        */
/*                                 */
/*                             3410-2001                                 */
/*  :                                                         */
/* -    : *Context ().                      */
/* -      PublicKey  .        */
/* -      MutualKey.                          */
/* :                                                                     */
/* -     MutualKey.                                        */
/*  :                                                             */
/* - RET_OK                -  .                           */
/* - RET_INCORRECTCONTEXT  -    . .  */
/* - RET_CONTEXTNOREADY    -    .           */
/* - RET_KEYNOTPRESENT     -    .                    */
/* - RET_INVALIDPARAMETER  -     .      */
/******************************************************************************/

/******************************************************************************/
/*Diffie/Hellman..............................................................*/
/******************************************************************************/
/******************************************************************************/
/*   ......................................*/
/******************************************************************************/

/******************************************************************************/
/*................................*/
/******************************************************************************/

int CrypC_Random_Fill( struct RND_State *State, void  *Field, int Bytes );
/******************************************************************************/
/*                    .                */
/******************************************************************************/
/*  :                                                         */
/* -    Field.                                               */
/* -     Bytes.                                            */
/* :                                                                     */
/* -       Bytes.     */
/*  :                                                             */
/* - RET_OK                -  .                           */
/* - RET_INVALIDPARAMETER  -     .      */
/******************************************************************************/

/******************************************************************************/
/*.................................................*/
/******************************************************************************/
/******************************************************************************/
/*     .................................*/
/******************************************************************************/

/******************************************END*/
