#include <string.h>
#include <sys/types.h>
#ifdef __GNUC__
#include <netinet/in.h>
#endif
//#ifdef __ICL
//#include <winsock.h>
//#endif
//#ifdef __WATCOMC__
//#include <winsock.h>
//#endif
#ifdef __CYG__
#include <sys/param.h>
#endif

union UQW {                        /* Unsigned Quad Word. */
          QWORD L;                 /* Long.               */
          DWORD S[2];              /* 2 Shorts.           */
          };
union ULW {                        /* Unsigned Long Word. */
          DWORD L;                 /* Long.               */
          WORD  S[2];              /* 2 Shorts.           */
          };
union USW {                        /* Unsigned Short Word.*/
          WORD  S;                 /* Short.              */
          BYTE  B[2];              /* 2 Bytes.            */
          };

#ifdef __ICL
           DWORD cdecl rdtick ( void  );
           DWORD cdecl htonl  (DWORD  );
            WORD cdecl htons  ( WORD  );
#define __READTSC__
#endif
#ifdef _MSC_VER
           DWORD cdecl rdtick ( void  );
           DWORD cdecl htonl  (DWORD  );
            WORD cdecl htons  ( WORD  );
#define __READTSC__
#endif
#ifdef __CCDL__
           DWORD       rdtick ( void  );
           DWORD       htonl  (DWORD  );
            WORD       htons  ( WORD  );
#define __READTSC__
#endif
#ifdef __WATCOMC__
           DWORD cdecl rdtick ( void  );
           DWORD cdecl htonl  (DWORD  );
            WORD cdecl htons  ( WORD  );
#define __READTSC__
#endif
#ifdef __GNUC__
           DWORD       rdtick ( void  );
//         DWORD       htonl  (DWORD  );
//          WORD       htons  ( WORD  );
#define __READTSC__
#endif
#ifdef __BORLANDC__
extern "C" DWORD       rdtick ( void  );
extern "C" DWORD       htonl  (DWORD  );
extern "C"  WORD       htons  ( WORD  );
#define __READTSC__
#endif
#ifndef __READTSC__
extern "C" DWORD cdecl rdtick ( void  );
extern "C" DWORD cdecl htonl  (DWORD  );
extern "C"  WORD cdecl htons  ( WORD  );
#define __READTSC__
#endif

//      .  DEBUG,     
//   34.10-1994  34.10-2001   
//     .
//           (Exp512, Exp1024,Curve256).
//       512-   34.10-1994    
//  34.10-2001     , ģ
//       . .
//
//#define DEBUG

/*******************************BEG*/
extern struct LR34_10_2001   _LC3410_Default0256;
extern DWORD  LO_[LNP];            /*   NP .  */

/******************************BEG*/

#if BYTE_ORDER == LITTLE_ENDIAN
#define CrypC_NetToHost(Buffer,DWords)                                        \
                      {                                                       \
                      int I;                                                  \
                      for(I=0;I<DWords;I++)                                   \
                         ((DWORD *)Buffer)[I]=htonl(((DWORD *)Buffer)[I]);    \
                      }
#else //__BYTE_ORDER == __BIG_ENDIAN
#define CrypC_NetToHost(Buffer,DWords) ;
#endif
#define CrypC_HostToNet(Buffer,DWords)                                        \
        CrypC_NetToHost(Buffer,DWords)

/*        Point:  ,    */
/*  ,  ,    -  */
/*     , etc.                                 */
#define Affi 0x00                               //     .
#define Proj 0x01                               //    . .
#define Mont 0x02                               //     .
#define MONT 0x80                               //    Montgomery Domain.

/**************************************************BEG*/
struct LPoint
       {
       DWORD  X  [LCuNP];			  /*  X.            */
       DWORD  Y  [LCuNP];			  /*  Y.            */
       DWORD  Z  [LCuNP];			  /*  Z.            */
       DWORD  Type;				  /*   .      */
       };
#define LPTSIZE sizeof(struct LPoint)

/******************************************BEG*/
struct RND_State
       {
       DWORD   X0_, Y0_;                /*       */
       DWORD   X1_, Y1_;                /*       */
       DWORD   X2_, Y2_;                /*       */
       DWORD   X3_, Y3_;                /*       */
       DWORD   x0_, y0_;                /*   */
       DWORD   x1_, y1_;                /*   */
       DWORD   x2_, y2_;                /*   */
       DWORD   x3_, y3_;                /*   */
       DWORD   OLZ_, F_;                /*      */
        WORD   Pass_;                   /*       */
        WORD   pass_;                   /*   */
       };
/*****************************************END*/

/*************************************************BEG*/
struct COM_State
       {
       BYTE    Perms[8][16];            /*   V16.         */
       DWORD   K_[4*256];               /* ,  . */
       BYTE    Ready;                   /*  .       */
       };
/************************************************END*/

/********************************************BEG*/

void    CrypC__InitGost( BYTE *Perms, DWORD *K_ );
/**/
/*                  */
/*                          28147-89.                      */
/**/
/*  :                                                        */
/* -    Perms (8*16 ) 8   V16               */
/* -    K_ (4*256 . )       */
/*       -          */
/*    . .                                                     */
/* !   ,      */
/*      CrypC__InitGost()  .             */
/* :                                                                    */
/* -   K_.                                                   */
/**/

void    CrypC__ClearGost( struct COM_State *Comm );
/**/
/*                       */
/*                          28147-89.                      */
/**/
/*  :                                                        */
/* -      Comm.                          */
/* :                                                                    */
/* -   K_  Comm.                                         */
/**/

void    CrypC_InitRandom_( struct RND_State *State );
/**/
/*               256          */
/*                                                      */
/**/

void    CrypC_ForceRandom_(struct RND_State *State,
                     DWORD _X0, DWORD _Y0,
                     DWORD _X1, DWORD _Y1,
                     DWORD _X2, DWORD _Y2,
                     DWORD _X3, DWORD _Y3,
                     char  _Pass           );
/**/
/*                256          */
/*                                                      */
/*                                              */
/**/
/*  :                                                        */
/* -  *State   .                                       */
/* -    Xi_, Yi_, i=0,...,3.                    */
/* -    Pass_.                                 */
/* :                                                                    */
/* -    Xi_, Yi_, i=0,...,3   Pass_      */
/*                 */
/*    .                                                   */
/**/

void    CrypC_RestrRandom_(struct RND_State *State);
/**/
/*                256            */
/*                                                      */
/**/
/*  :                                                        */
/* -  *State   .                                       */
/* :                                                                    */
/* -             */
/*   Xi_, Yi_, i=0,...,3   Pass_.                                 */
/**/

int     CrypC_FillByRandom_( struct RND_State *State, void *Buf, long LenInBytes );
/**/
/*                              */
/**/
/*  :                                                        */
/* -  *State   .                                       */
/* -  *Buf     .                   */
/* -  LenInBytes  Buf  .                                   */
/* :                                                                    */
/* -   *Buf     LenInBytes .    */
/**/

void    CrypC__Hash(DWORD *K_, BYTE *H, BYTE *M);
/**/
/*                              -                           */
/**/
/*  :                                                        */
/* -  K_      28147.         */
/* -   - -  H  NQ*4 .              */
/* -     -  M  NQ*4 .                  */
/* :                                                                    */
/* -   -   H.                        */
/**/

int     CrypC_LCuSign(struct LR34_10_2001 *Context, DWORD *SField);
/**/
/*                                 */
/**/
/*  :                                                        */
/* -   *SField  3*CuNQ 32- , -           */
/*        CuNQ 32-  - H.         */
/* :                                                                    */
/* -  :                                                           */
/*   - 0   -   .                                     */
/* -      NQ 32-   SField          */
/*   , ,   r' s.                      */
/**/

int     CrypC_LCuCheck(struct LR34_10_2001 *Context, DWORD *SField);
/**/
/*                                  */
/**/
/*  :                                                        */
/* -   *SField,                    */
/*     CuNQ 32-   , -             */
/*      , :                           */
/*   - - H,                                                         */
/*   -   r',                                                     */
/*   -   s .                                                     */
/* -    .                                         */
/* :                                                                    */
/* -  :                                                           */
/*   - RET_OK             -  ,  .      */
/*   - RET_INCORRECTSIGN  -  ,  .      */
/*   - RET_ZERO_R         -     r'.              */
/*   - RET_ZERO_S         -     s .              */
/*   - RET_BAD_R          -     r'.         */
/*   - RET_BAD_S          -     s .         */
/**/

int     CrypC_LroundC(DWORD *C, DWORD *B, DWORD *P, int L);
/**/
/*                       */
/*                        C = (B * 2**(32*L))(mod P)                         */
/**/

int     CrypC_LpowerC(DWORD *Y, DWORD *M, DWORD *Out, int Ind, DWORD *P, int L);
/**/
/*     : Out = ((Y ** M) * 1**Ind) (mod P), Ind = 0  1   */
/**/
/*  :                                                        */
/* -  *Y  ,   .                    */
/* -  *M  ,   .                   */
/* -  *Out     .                      */
/* -     1  :  0  1.       */
/* -  *P  ,    .               */
/* -  L  32-   Y, M, P  Out.                     */
/* :                                                                    */
/* -     M   Out.                            */
/**/

void    CrypC_LCuPower(struct LPoint       *Y      ,
                               DWORD       *M      ,
                       struct LPoint       *Out    ,
                       struct LR34_10_2001 *Context);
/**/
/*    Y ,   Context,   M:      */
/* Out = (Y * M).                                                            */
/**/
/*  :                                                        */
/* -  *Y  ,    .      */
/* -  *M  ,    (CuNQ ).          */
/* -  *Out     .                              */
/* :                                                                    */
/* -     M   Out.                             */
/**/

int     CrypC_LmultC(DWORD *B, DWORD *C, DWORD *P, int L);
/**/
/*                        P                     */
/**/
/*  :                                                        */
/* -  *B  ,    .             */
/* -  *C  ,    .             */
/* -  *P  ,    .               */
/* -  L  32-   B, C, P.                           */
/* :                                                                    */
/* -   B*C (mod P)      B.       */
/**/

int     CrypC_LmultCm(DWORD *B, DWORD *C, DWORD *P, int L);
/**/
/*                        P                     */
/**/
/*  :                                                        */
/* -  *B  ,    .             */
/* -  *C  ,    .             */
/*       Mask_SecretKey_                 */
/*     .                                                    */
/* -  *P  ,    .               */
/* -  L  32-   B, C, P.                           */
/* :                                                                    */
/* -   B*C (mod P)      B.       */
/**/

int     CrypC_Lpower2C(DWORD *B, DWORD *P, int L);
/**/
/*                     P              */
/**/
/*  :                                                        */
/* -  *B  ,  .                              */
/* -  *P  ,    .               */
/* -  L  32-   B, P.                              */
/* :                                                                    */
/* -   B*B (mod P)     B.              */
/**/

int     CrypC_LCuAdd(struct LR34_10_2001 *Context, struct LPoint *B, struct LPoint *C);
/**/
/*      B  C  ,            */
/* .                                                               */
/**/
/*       B.                           */
/*  -   , ..,     (X,Y,Z)  */
/*  CuNP .                                                             */
/**/

int     CrypC_LCuDub(struct LR34_10_2001 *Context, struct LPoint *B);
/**/
/*     B  ,  .     */
/**/
/*       B.                           */
/*  -   , ..,     (X,Y,Z)  */
/*  CuNP .                                                             */
/**/

int     CrypC_LAffiToProj(struct LR34_10_2001 *Context, struct LPoint *B);
/**/
/*          .   */
/**/
/*  B -    mod P:                                        */
/*            - (Xv,Yv,Undefined),                                    */
/*           - (Xp,Yp,Zp) = (Xv,Yv,1).                               */
/**/

int     CrypC_LProjToAffi(struct LR34_10_2001 *Context, struct LPoint *B);
/**/
/*         .    */
/**/
/*  B -    mod P:                                        */
/*            - (Xp,Yp,Zp),                                           */
/*           - (Xv,Yv,Zv=Undefined),                                 */
/*                     (Xv,Yv) = (Xp/(Zp^2),Yp/(Zp^3)),                      */
/*  Zv  ,  Σ  1/Zp.                                   */
/**/

int     CrypC_LIntToMont(struct LR34_10_2001 *Context, struct LPoint *B);
/**/
/*      Montgomery Domain.                   */
/**/

int     CrypC_LMontToInt(struct LR34_10_2001 *Context, struct LPoint *B);
/**/
/*      Montgomery Domain  Z.              */
/**/

void    CrypC_LCuModuloPQ(DWORD *Dividend, struct LR34_10_2001 *Context);
/**/
/*    Q  P- (Curve-).                    */
/**/

void    CrypC_LCuModuloQQ(DWORD *Dividend, struct LR34_10_2001 *Context);
/**/
/*    Q  Q- (Curve-).                    */
/**/

int     CrypC_Lcmp_LC(int L, DWORD *Left, DWORD *Rigt);
/**/
/*          L 32- .    */
/**/
/*  <=> 0.                                                         */
/**/

int     CrypC_Lsub_LC(int L, DWORD *Left, DWORD *Rigt);
/**/
/*          L 32- :    */
/*                      Left -= Rigt (mod 2**(32*L))                         */
/**/
/*  <=> 0.                                                         */
/**/

int     CrypC_Ladd_LC(int L, DWORD *Left, DWORD *Rigt);
/**/
/*           L 32- :    */
/*                      Left += Rigt (mod 2**(32*L))                         */
/**/
/*      .                              */
/**/

int     CrypC__add_LbC(int L, BYTE *Left, BYTE *Rigt);
/**/
/*           L  8- :    */
/*                      Left += Rigt (mod 2**(8*L))                          */
/**/
/*      .                              */
/**/

void    CrypC_Ldiv_LC (int L, DWORD *Dividend, DWORD *Divisor, DWORD *Quotient, DWORD *Rest);
/**/
/*        L 32-   */
/*      L 32- .                   */
/**/

void    CrypC_Ladd_PC(int L, DWORD *Left, DWORD *Rigt, DWORD *P);
/**/
/*          L 32-     */
/*                       P   :                               */
/*                      Left += Rigt (mod P).                                */
/**/

void    CrypC_Lsub_PC(int L, DWORD *Left, DWORD *Rigt, DWORD *P);
/**/
/*         L 32-     */
/*                       P   :                               */
/*                      Left += Rigt (mod P).                                */
/**/

int     CrypC_Lshl_LC(int L, DWORD *F);
/**/
/*    1      L 32-  */
/*                                  .                                    */
/**/
/*   ,     .         */
/**/

int     CrypC_Lshr_LC(int L, DWORD *F);
/**/
/*    1      L 32- */
/*                                  .                                    */
/**/
/*   ,     .         */
/**/

void    CrypC__GOSTE (DWORD *K, DWORD *X, DWORD *P, DWORD *C);
/**/
/*          28147-89 */
/*                                                     */
/**/
/*  :                                                        */
/* -    K  .                      */
/* -    (NK*4*2 )   *X,   */
/*    Mask_SecretKey_.                                             */
/* -    (8 )   *P.                         */
/* -    (8 )    *.                  */
/* :                                                                    */
/* -    (8 ),    *C.             */
/**/

void    CrypC__GOSTE_(DWORD *K, DWORD *X, DWORD *P, DWORD *C);
/**/
/*          28147-89 */
/*                                                   */
/**/
/*  :                                                        */
/* -    K  .                      */
/* -    (NK*4 )   *X.                     */
/* -    (8 )   *P.                         */
/* -    (8 )    *.                  */
/* :                                                                    */
/* -    (8 ),    *C.             */
/**/

void    CrypC__GOSTD (DWORD *K, DWORD *X, DWORD *P, DWORD *C);
/**/
/*                      */
/*                 28147-89                        */
/**/
/*  :                                                        */
/* -    K  .                      */
/* -    (NK*4*2 )   *X,  */
/*    Mask_SecretKey_.                                             */
/* -    (8 )   *P.                      */
/* -    (8 )    *.                     */
/* :                                                                    */
/* -    (8 ),    *C.                */
/**/

void    CrypC__GOSTD_(DWORD *K, DWORD *X, DWORD *P, DWORD *C);
/**/
/*                      */
/*                28147-89                       */
/**/
/*  :                                                        */
/* -    K  .                      */
/* -    (NK*4 )   *X.                    */
/* -    (8 )   *P.                      */
/* -    (8 )    *.                     */
/* :                                                                    */
/* -    (8 ),    *C.                */
/**/


void    CrypC__GOSTA (DWORD *K, DWORD *X, DWORD *I, DWORD *P);
/**/
/*                 28147-89             */
/*                                                     */
/**/
/*  :                                                        */
/* -    K  .                      */
/* -    (NK*4*2 )   *X,   */
/*    Mask_SecretKey_.                                             */
/* -    (8 )    *I.          */
/* -    (8 )   *P.                         */
/* :                                                                    */
/* -    (8 ),    *I.         */
/**/

void    CrypC__GOSTA_(DWORD *K, DWORD *X, DWORD *I, DWORD *P);
/**/
/*                 28147-89             */
/*                                                   */
/**/
/*  :                                                        */
/* -    K  .                      */
/* -    (NK*4 )   *X.                     */
/* -    (8 )    *I.          */
/* -    (8 )   *P.                         */
/* :                                                                    */
/* -    (8 ),    *I.         */
/**/

int     CrypC_Mask_SecretKey_( struct RND_State *State, void  *Sec );
/**/
/*                              */
/**/
/*  :                                                        */
/* -   -  NK*4  NK*4*2-   *Sec.     */
/* :                                                                    */
/* -         NK*2    */
/*     Sec.                                                        */
/* -       NK*4   Sec.    */
/* -      (  32 )  */
/*     2**32           */
/*   .                                                                  */
/**/

int     CrypC_ReMask_SecretKey_( struct RND_State *State, void  *Sec );
/**/
/*                                */
/**/
/*  :                                                        */
/* -    - NK*4*2-   *Sec.         */
/* :                                                                    */
/* -         NK*4    */
/*     Sec.                                                        */
/* -       NK*4   Sec.    */
/* -      (  32 )  */
/*     2**32           */
/*   .                                                                  */
/**/

int     CrypC_Gen_SecretKey_( struct RND_State *State, void  *Sec, int Keys );
/**/
/*        Keys     NK*4       */
/*  :                                                        */
/**/
/* -   *Sec (Keys*NK*4 ).                                      */
/* :                                                                    */
/* - Keys      *Sec.                       */
/**/

/********************************************END*/
