#ifndef DWORD
typedef unsigned char      BYTE;
typedef unsigned short     WORD;
#ifdef __arch64__
typedef unsigned int       DWORD;
typedef unsigned long      QWORD;
#else
#ifdef __x86_64__
typedef unsigned int       DWORD;
typedef unsigned long      QWORD;
#else
typedef unsigned long      DWORD;

#ifdef _MSC_VER
typedef unsigned __int64   QWORD;
#else 
typedef unsigned long long QWORD;
#endif

#endif
#endif
typedef          short int SINT;
typedef          long  int LINT;
#endif

//   WS -    ᫮  ࠬ஢ .
//          ᥪ⭮  ஢ ᥣ 4 .
//   NK - ࠧ  ஢    4-⮢ ᫮.
//   NQ - ࠧ  Q  34.10-1994  ᫮  WS.
//   NP -  ࠧ  P  34.10-1994  ᫮  WS.
// CuNQ - ࠧ  Q  34.10-2001  ᫮  WS.
// CuNP -  ࠧ  P  34.10-2001  ᫮  WS.
//        ࠬ, 塞   P  Q, ࠧ  
//        ࠧ஢ ᮮ⢥ 㫥.

#define   LWS   4
#define   LNK   8
#define   LNQ   8
#define   LNP  64
#define LCuNQ   8
#define LCuNP   8

#include "CrC_Kernel.h"

#ifndef NULL
#define NULL 0
#endif

/**************************************************************BEG*/
#define RET_OK                0
#define RET_CONTEXTNOTCLEAR   1
#define RET_CONTEXTNOTREADY   2
#define RET_KEYNOTPRESENT     3
#define RET_KEYALREADYPRESENT 4
#define RET_INCORRECTSIGN     5
#define RET_ZERO_R            6
#define RET_ZERO_S            7
#define RET_BAD_R             8
#define RET_BAD_S             9
#define RET_FILE_OPEN        10
#define RET_FILE_SEEK        11
#define RET_FILE_READ        12
#define RET_FILE_CLOSE       13
#define RET_INCORRECTCONTEXT 14
#define RET_INVALIDPARAMETER 15
#define RET_INCORRECTSIZE    16

#define GOST_XXXXX_Marker_Mask        0xFFFFFFF0
#define G28147_1989_block_Marker      0x9ABCDEF7
#define G28147_1989_gamma_Marker      0x9ABCDEF1
#define G28147_1989_gamma_ofb_Marker  0x9ABCDEF2
#define G28147_1989_mac_Marker        0x9ABCDEF3
#define R34_11_1994_Marker            0x9ABCDEF4
#define R34_10_1994_Marker            0x9ABCDEF5
#define R34_10_2001_Marker            0x9ABCDEF7
#define DH_PKA_Marker                 0x9ABCDEF6

/*****34-10**************************************BEG*/
#define R34_10_1994_CONTEXT    1
#define R34_10_1994_SECRETKEY  2
#define R34_10_1994_PUBLICKEY  4
#define R34_10_2001_CONTEXT    1
#define R34_10_2001_SECRETKEY  2
#define R34_10_2001_PUBLICKEY  4

/****Diffie/Hellman***********************************BEG*/
#define DH_PKA_CONTEXT    1
#define DH_PKA_SECRETKEY  2
#define DH_PKA_PUBLICKEY  4

/**********************************************************BEG*/
/**28147*******************************************************************/
/* ................................................................*/
struct G28147_1989_block
       {
       DWORD  Mark            ;                   /* Context Marker.          */
       DWORD  SecretKey[LNK*2];                   /*  ஢  ᪠. */
         int  IsReady         ;                   /*  ...Init().     */
       struct RND_State *RS   ;                   /* ﭨ .           */
       struct COM_State *PE   ;                   /* ⠭.             */
       };
/*஢................................................................*/
struct G28147_1989_gamma
       {
       DWORD  Mark            ;                   /* Context Marker.          */
       DWORD  SecretKey[LNK*2];                   /*  ஢  ᪠. */
        BYTE  Feed     [    8];                   /*  மࠧ .    */
        BYTE  Gamma    [    8];                   /*   .    */
         int  GammaOffs       ;                   /* . ᬥ饭  .   */
         int  IsReady         ;                   /*  ...Init().     */
       struct RND_State *RS   ;                   /* ﭨ .           */
       struct COM_State *PE   ;                   /* ⠭.             */
       };
/*஢  ⭮   ⥪................................*/
struct G28147_1989_gamma_ofb
       {
       DWORD  Mark            ;                   /* Context Marker.          */
       DWORD  SecretKey[LNK*2];                   /*  ஢  ᪠. */
        BYTE  FeedBack [    8];                   /*  ⭮ 裡.     */
        BYTE  Gamma    [    8];                   /*   .    */
         int  GammaOffs       ;                   /* . ᬥ饭  .   */
         int  IsReady         ;                   /*  ...Init().     */
       struct RND_State *RS   ;                   /* ﭨ .           */
       struct COM_State *PE   ;                   /* ⠭.             */
       };
/*ࠡ⪠ ⮢......................................................*/
struct G28147_1989_mac
       {
       DWORD  Mark            ;                   /* Context Marker.          */
       DWORD  SecretKey[LNK*2];                   /*  ஢  ᪠. */
        BYTE  Feed     [    8];                   /*   ⥪.    */
       DWORD  MAC      [    2];                   /* 騩 ⮢.     */
         int  GammaOffs       ;                   /* . ᬥ饭  .   */
         int  IsReady         ;                   /*  ...Init().     */
       struct RND_State *RS   ;                   /* ﭨ .           */
       struct COM_State *PE   ;                   /* ⠭.             */
       };
/**34-11******************************************************************/
/*ࠡ⪠ -.......................................................*/
struct R34_11_1994
       {
       DWORD  Mark         ;                      /* Context Marker.          */
        BYTE  Feed  [LNQ*4];                      /*   ⥪.    */
        BYTE  Digest[LNQ*4];                      /* 騩 -.      */
        BYTE  SumVec[LNQ*4];                      /*  㬬 .    */
         int  MsgLength    ;                      /* 稪  ᮮ饭. */
         int  BlockOffs    ;                      /* . ᬥ饭  .   */
         int  IsReady      ;                      /*  ...Init().     */
       struct RND_State *RS;                      /* ﭨ .           */
       struct COM_State *PE;                      /* ⠭.             */
       };
/**34-10******************************************************************/
/*᫥/஢ઠ ஢   34-10-1994.......................*/
struct LR34_10_1994
       {
       DWORD  Mark            ;                   /* Context Marker.          */
       DWORD  SecretKey[LNQ*2];                   /* . .  .*/
       DWORD  PublicKey[LNP  ];                   /* .        .*/
       DWORD  P_  [LNP+1]     ;                   /* ⮥      P.    (HBO) */
       DWORD  Q_  [LNQ+1]     ;                   /* ⮥      Q.    (HBO) */
       DWORD  A_  [LNP  ]     ;                   /* ஦騩  A.    (HBO) */
       DWORD  AP_ [LNP  ]     ;                   /* ਢ [A]P.  (HBO) */
         int  P_Size          ;                   /*  ⮣ P (). */
         int  Q_Size          ;                   /*  ⮣ Q (). */
         int  IsReady         ;                   /*  樠樨.     */
       struct RND_State *RS   ;                   /* ﭨ .           */
       };
/*᫥/஢ઠ ஢   34-10-2001.......................*/
/* - PG_  樥 室  Montgomery Domain  mod P  ࠧ-   */
/*    P_SIZE*8:            [X]P = MontMult(X,PG_)(mod P).                */
struct LR34_10_2001
       {
       DWORD  Mark              ;  		  /* Context Marker.          */
       DWORD  SecretKey[LCuNQ*2];                 /* . .  .*/
struct LPoint PublicKey         ;                 /* .        .*/
       DWORD  a_       [LCuNP  ];                 /* ࠬ a ਢ. (HBO) */
       DWORD  b_       [LCuNP  ];                 /* ࠬ b ਢ. (HBO) */
       DWORD  P_       [LCuNP+1];                 /* ⮥      P.    (HBO) */
       DWORD  PG_      [LCuNP  ];                 /* 2^(2nP)(mod P).    (HBO) */
       DWORD  Q_       [LCuNQ+1];                 /* ⮥      Q.    (HBO) */
       DWORD  QG_      [LCuNQ  ];                 /* 2^(2nQ)(mod Q).    (HBO) */
       DWORD  QP_      [LCuNP+1];                 /* ⮥ Q  CuNP.    */
       DWORD  OQ_      [LCuNQ  ];                 /* [1]Q  CuNQ.   (HBO) */
       DWORD  OP_      [LCuNP  ];                 /* [1]P  CuNP.   (HBO) */
       DWORD  OQP_     [LCuNP  ];                 /* [1]Q  CuNP.   (HBO) */
struct LPoint A_                ;                 /* 窠 A ਢ.    (HBO) */
struct LPoint AP_               ;                 /* ਢ񭭠 [A_]P. (HBO) */
       DWORD  Half     [LCuNP  ];                 /* [1/2]P.            (HBO) */
         int  P_Size            ;                 /*  ⮣ P (). */
         int  Q_Size            ;                 /*  ⮣ Q (). */
         int  IsReady           ;                 /*  樠樨.     */
       struct RND_State *RS     ;                 /* ﭨ .           */
       };
/*Diffie/Hellman***************************************************************/
/*᫥ ᮢ 祩 ⮢......................................*/
struct LDH_PKA
       {
       DWORD  Mark          ;                     /* Context Marker.          */
       DWORD  SecretKey[LNP];                     /* . .  .*/
       DWORD  PublicKey[LNP];                     /* .         .*/
       DWORD  P_  [LNP+1]   ;                     /* ⮥      P.    (HBO) */
       DWORD  A_  [LNP  ]   ;                     /* ஦騩  A.    (HBO) */
       DWORD  AP_ [LNP  ]   ;                     /* ਢ [A]P.  (HBO) */
         int  P_Size        ;                     /*  ⮣ P (). */
         int  IsReady       ;                     /*  樠樨.     */
       struct RND_State *RS ;                     /* ﭨ .           */
       };
/**********************************************************END*/

/******************************************BEG*/
/**/
/*.28147..................................................................*/
/**/
/**/
/* ..............................................................*/
/**/

int CrypC_G28147_1989_block_init(struct G28147_1989_block *Context, struct COM_State *PE, struct RND_State *State, void *_Sec);
/**/
/*                        樠 ⥪                             */
/*                          筮 ஢                               */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫   ᪨஢ ᥪ⭮ : *Sec (NK*4 ).  */
/* 室:                                                                     */
/* - ⥪, ⮢  ஢  ஢ .               */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_INCORRECTCONTEXT  - । 樠஢ ⥪ . ०.  */
/* - RET_CONTEXTNOTCLEAR                                                      */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_G28147_1989_block_encrypt(struct G28147_1989_block *EContext, void *_IBuff, void *_OBuff, int BlkCount);
/**/
/*                ஢                      */
/*                        ० 筮 ஢                         */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *EContext ().                     */
/* - ⥫      ஢ *IBuff.              */
/* - ⥫    ⥪ *OBuff.                                */
/* - ᫮     *IBuf BlkCount.                             */
/* 室:                                                                     */
/* - ஢    *OBuff.                                    */
/*  :                                                             */
/* - RET_OK                                                                   */
/* - RET_INCORRECTCONTEXT  - । 樠஢ ⥪ . ०.  */
/* - RET_CONTEXTNOTREADY                                                      */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_G28147_1989_block_decrypt(struct G28147_1989_block *DContext, void *_IBuff, void *_OBuff, int BlkCount);
/**/
/*              ஢   ஢                 */
/*                        ० 筮 ஢                         */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *DContext ().                     */
/* - ⥫   ஢   ஢ *IBuff.          */
/* - ⥫    ⮣ ⥪ *OBuff.                          */
/* - ᫮     *IBuf BlkCount.                             */
/* 室:                                                                     */
/* - ஢    *OBuff.                                   */
/*  :                                                             */
/* - RET_OK                                                                   */
/* - RET_INCORRECTCONTEXT  - । 樠஢ ⥪ . ०.  */
/* - RET_CONTEXTNOTREADY                                                      */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_G28147_1989_block_clear(struct G28147_1989_block *Context);
/**/
/*                           ⪠ ⥪                                */
/*                          筮 ஢                               */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* 室:                                                                     */
/* - 饭  ⥪.                                               */
/*  :                                                             */
/* - RET_OK                                                                   */
/* - RET_INCORRECTCONTEXT  - । 樠஢ ⥪ . ०.  */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

/**/
/*஢................................................................*/
/**/

int CrypC_G28147_1989_gamma_init(struct G28147_1989_gamma *Context, struct COM_State *PE, struct RND_State *State, void *_Sec, void *_Sync);
/**/
/*                        樠 ⥪                             */
/*               ஢ ⮪   ० ஢               */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫   ᪨஢ ᥪ⭮ : *Sec (NK*4 ).  */
/* - ⥫   ᨭய뫪: *Sync (8 ).                        */
/*             ᫨ 㪠⥫ ࠢ 0,  ਭ 㫥 ᨭய뫪.  */
/* 室:                                                                     */
/* - ⥪, ⮢  ஢  ஢ .               */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_INCORRECTCONTEXT  - । 樠஢ ⥪ . ०.  */
/* - RET_CONTEXTNOTCLEAR                                                      */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_G28147_1989_gamma_clear(struct G28147_1989_gamma *Context);
/**/
/*                           ⪠ ⥪                                */
/*             ஢ ⮪   ० ஢                 */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* 室:                                                                     */
/* - 饭  ⥪.                                               */
/*  :                                                             */
/* - RET_OK                                                                   */
/* - RET_INCORRECTCONTEXT  - । 樠஢ ⥪ . ०.  */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_G28147_1989_gamma_crypt(struct G28147_1989_gamma *Context, void *IBuff, void *OBuff, LINT LenBuff);
/**/
/*                ()஢ ࠣ ⮪                    */
/*                         ० ஢                               */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫    (஢)                       */
/*   ஢ (஢) *IBuff.                                     */
/* - ⥫    ⥪ ( ) *OBuff.              */
/* -     *IBuf   LenBuff.                            */
/* 室:                                                                     */
/* - ()஢    *OBuff.                               */
/*  :                                                             */
/* - RET_OK                                                                   */
/* - RET_INCORRECTCONTEXT  - । 樠஢ ⥪ . ०.  */
/* - RET_CONTEXTNOTREADY                                                      */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

/**/
/*஢  ⭮   ⥪................................*/
/**/

int CrypC_G28147_1989_gamma_ofb_init(struct G28147_1989_gamma_ofb *Context, struct COM_State *PE, struct RND_State *State, void *Sec, void *Sync);
/**/
/*                        樠 ⥪                             */
/*      ஢ ⮪   ० ஢  ⭮       */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫   ᪨஢ ᥪ⭮ : *Sec (NK*4 ).  */
/* - ⥫   ᨭய뫪: *Sync (8 ).                        */
/*             ᫨ 㪠⥫ ࠢ 0,  ਭ 㫥 ᨭய뫪.  */
/* 室:                                                                     */
/* - ⥪, ⮢  ஢  ஢ .               */
/*  :                                                             */
/* - RET_OK                                                                   */
/* - RET_INCORRECTCONTEXT  - । 樠஢ ⥪ . ०.  */
/* - RET_CONTEXTNOTCLEAR                                                      */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_G28147_1989_gamma_ofb_clear(struct G28147_1989_gamma_ofb *Context);
/**/
/*                           ⪠ ⥪                                */
/*      ஢ ⮪   ० ஢  ⭮       */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* 室:                                                                     */
/* - 饭  ⥪.                                               */
/*  :                                                             */
/* - RET_OK                                                                   */
/* - RET_INCORRECTCONTEXT  - । 樠஢ ⥪ . ०.  */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_G28147_1989_gamma_ofb_encrypt(struct G28147_1989_gamma_ofb *EContext, void *IBuff, void *OBuff, LINT LenBuff);
/**/
/*                   ஢ ࠣ ⮪                      */
/*                   ० ஢  ⭮                    */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *EContext ().                     */
/* - ⥫      ஢ *IBuff.              */
/* - ⥫    ⥪ *OBuff.                                */
/* -     *IBuf   LenBuff.                            */
/* 室:                                                                     */
/* - ஢    *OBuff.                                    */
/*  :                                                             */
/* - RET_OK                                                                   */
/* - RET_INCORRECTCONTEXT  - । 樠஢ ⥪ . ०.  */
/* - RET_CONTEXTNOTREADY                                                      */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_G28147_1989_gamma_ofb_decrypt(struct G28147_1989_gamma_ofb *DContext, void *IBuff, void *OBuff, LINT LenBuff);
/**/
/*                   ஢ ࠣ ⮪                     */
/*                   ० ஢  ⭮                    */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *DContext ().                     */
/* - ⥫   ⥪  ஢ *IBuff.                  */
/* - ⥫      *OBuff.                           */
/* -     *IBuf   LenBuff.                            */
/* 室:                                                                     */
/* - ஢    *OBuff.                                   */
/*  :                                                             */
/* - RET_OK                                                                   */
/* - RET_INCORRECTCONTEXT  - । 樠஢ ⥪ . ०.  */
/* - RET_CONTEXTNOTREADY                                                      */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

/**/
/*ࠡ⪠ ⮢......................................................*/
/**/

int CrypC_G28147_1989_mac_init(struct G28147_1989_mac *Context, struct COM_State *PE, struct RND_State *State, void *Sec, void *Sync);
/**/
/*                        樠 ⥪                             */
/*                   ࠡ⪨ ⮢ ᮮ饭                         */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫   ᪨஢ ᥪ⭮ : *Sec (NK*4 ).  */
/* - ⥫   ᨭய뫪: *Sync (8 ).                        */
/*             ᫨ 㪠⥫ ࠢ 0,  ਭ 㫥 ᨭய뫪.  */
/* 室:                                                                     */
/* - ⥪, ⮢  ࠡ⪥ ⮢.                              */
/*  :                                                             */
/* - RET_OK                                                                   */
/* - RET_INCORRECTCONTEXT  - । 樠஢ ⥪ . ०.  */
/* - RET_CONTEXTNOTCLEAR                                                      */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_G28147_1989_mac_update(struct G28147_1989_mac *Context, void *Buff, LINT LenBuff);
/**/
/*           䨪 ⮢ ᮮ饭 ࠣ⮬ ᮮ饭          */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫   ⥪  ⥭䨪樨 *Buff.                      */
/* -     *Buf   LenBuff.                             */
/* 室:                                                                     */
/* - ஢ ﭨ ⥪.                                    */
/*  :                                                             */
/* - RET_OK                                                                   */
/* - RET_CONTEXTNOTREADY                                                      */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_G28147_1989_mac_final(struct G28147_1989_mac *Context, void *mac);
/**/
/*           襭 ࠡ⪨ ⮢ ᮮ饭  뤠          */
/*                           뢠饩 ணࠬ                             */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫    । ⮢ *mac.                       */
/* 室:                                                                     */
/* -  । ⮢ ᮤন ⮢ ᮮ饭.              */
/*  :                                                             */
/* - RET_OK                                                                   */
/* - RET_CONTEXTNOTREADY                                                      */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_G28147_1989_mac_clear(struct G28147_1989_mac *Context);
/**/
/*                           ⪠ ⥪                                */
/*                   ࠡ⪨ ⮢ ᮮ饭                         */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* 室:                                                                     */
/* - 饭  ⥪.                                               */
/*  :                                                             */
/* - RET_OK                                                                   */
/* - RET_INCORRECTCONTEXT  - । 樠஢ ⥪ . ०.  */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_G28147_1989_mac_file_const( char *FileSpec, void *mac );
/**/
/*             ᫥ ⮢ 䠩  ﭭ               */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫ *FileSpec    ASCIIZ-ப, ᮤঠ饩 ᯥ䨪   */
/*   䠩.                                                                   */
/* - ⥫   *mac  8   ࠧ饭 ᫥ -    */
/*   ⮢ 䠩.                                                         */
/* 室:                                                                     */
/* - ⮢ 䠩   *mac                                          */
/*  :                                                             */
/* - RET_OK             - ⮢ ᫥ ᯥ譮.                       */
/* - RET_FILE_OPEN      - 訡  ⨨ 䠩.                          */
/* - RET_FILE_SEEK      - 訡 樮஢  䠩.                    */
/* - RET_FILE_READ      - 訡  ⥭   䠩.                  */
/* - RET_FILE_CLOSE     - 訡  ⨨ 䠩.                          */
/*    㫥   ᮤন  *mac ।᪠㥬       */
/*   ।⠢ ᮡ १ ன ஬筮 䠧 ᫥.    */
/**/

/**/
/*.34-11.................................................................*/
/**/
/**/
/*ࠡ⪠.-.......................................................*/
/**/

int CrypC_R34_11_1994_init(struct R34_11_1994 *Context, struct COM_State *PE, struct RND_State *State, void *Sync);
/**/
/*                        樠 ⥪                             */
/*                         ࠡ⪨ -                              */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫   砫쭮 祭 - *Sync (NQ*2 ).   */
/*             ᫨ 㪠⥫ ࠢ 0,  ਭ 㫥 .     */
/* 室:                                                                     */
/* - ⥪, ⮢  ࠡ⪥ -.                               */
/*  :                                                             */
/* - RET_OK                                                                   */
/* - RET_INCORRECTCONTEXT  - । 樠஢ ⥪ . ०.  */
/* - RET_CONTEXTNOTCLEAR                                                      */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_R34_11_1994_update(struct R34_11_1994 *Context, void *Buff, LINT LenBuff);
/**/
/*           䨪 - ᮮ饭 ࠣ⮬ ᮮ饭           */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫   ⥪  ஢ *Buff.                         */
/* -     *Buf   LenBuff.                             */
/* 室:                                                                     */
/* - ஢ ﭨ ⥪.                                    */
/*  :                                                             */
/* - RET_OK                                                                   */
/* - RET_CONTEXTNOTREADY                                                      */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_R34_11_1994_final(struct R34_11_1994 *Context, void *Digest);
/**/
/*           襭 ࠡ⪨ ⮢ ᮮ饭  뤠          */
/*                           뢠饩 ணࠬ                             */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫    । - *Digest.                     */
/* 室:                                                                     */
/* -  । - ᮤন - ᮮ饭.                */
/*  :                                                             */
/* - RET_OK                                                                   */
/* - RET_CONTEXTNOTREADY                                                      */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_R34_11_1994_clear(struct R34_11_1994 *Context);
/**/
/*                           ⪠ ⥪                                */
/*                         ࠡ⪨ -                              */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* 室:                                                                     */
/* - 饭  ⥪.                                               */
/*  :                                                             */
/* - RET_OK                                                                   */
/* - RET_INCORRECTCONTEXT  - । 樠஢ ⥪ . ०.  */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

/**/
/*.34-10.................................................................*/
/**/
/**/
/*ࠡ⪠/஢ઠ ஢ .........................................*/
/**/

int CrypC_LR34_10_1994_set_parms(struct LR34_10_1994 *Context,
                                 struct RND_State  *State, 
                                 void  *R34_10_1994_P, int P_Size,
                                 void  *R34_10_1994_Q, int Q_Size,
                                 void  *R34_10_1994_A
                                );
/**/
/*                 ⠭ ࠬ஢ ஢                       */
/*              ⥪ ࠡ⪨/஢ન ஢                  */
/*                     ("樠" ⥪)                            */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫    P_Size   ⮣ 浪 P: *R34_11_1994_P.    */
/* - ⥫    Q_Size   ⮣ 浪 Q: *R34_10_1994_Q.    */
/* - ⥫   ਬ⨢  㯯 A: *R34_10_1994_A.    */
/*   ᫨ - 㪠⥫ ࠢ 0,   ࠬ  㬮砭    */
/*     P_Size  ⠢ 䫠 ⮢ ⥪. ⠫     */
/*   ࠬ .                                                  */
/* 室:                                                                     */
/* - ⥪, ⮢  ⠭ ᥪ⭮ / ⮣  .  */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_CONTEXTNOTCLEAR   - ⥪ 樠஢ ࠭.                  */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LR34_10_2001_set_parms(struct   LR34_10_2001 *Context,
                                 struct   RND_State  *State,
                                 void   *_R34_10_2001_P, int P_Size,
                                 void   *_R34_10_2001_Q, int Q_Size,
                                 void   *_R34_10_2001_a,
                                 void   *_R34_10_2001_b,
                          struct LPoint * R34_10_2001_A
                                );
/**/
/*                 ⠭ ࠬ஢ ஢                       */
/*              ⥪ ࠡ⪨/஢ન ஢                  */
/*                     ("樠" ⥪)                            */
/*                             3410-2001                                 */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫    P_Size   ⮣ 浪 P: *GOST_C3411_P.     */
/* - ⥫    Q_Size   ⮣ 浪 Q: *R34_10_2001_Q.    */
/* - ⥫    *P_Size  ࠬ a ਢ: *R34_10_2001_a.    */
/* - ⥫    *P_Size  ࠬ b ਢ: *R34_10_2001_b.    */
/* - ⥫             窨 A ਢ: *R34_10_2001_A.    */
/*   ᫨ - 㪠⥫ ࠢ 0,   ࠬ  㬮砭    */
/*     P_Size  ⠢ 䫠 ⮢ ⥪. ⠫     */
/*   ࠬ .                                                  */
/* 室:                                                                     */
/* - ⥪, ⮢  ⠭ ᥪ⭮ / ⮣  .  */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_INCORRECTCONTEXT  - । 樠஢ ⥪ . ०.  */
/* - RET_CONTEXTNOTCLEAR   - ⥪ 樠஢ ࠭.                  */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LR34_10_1994_get_parms(struct LR34_10_1994 *Context,
                                 void  *R34_10_1994_P, int *P_Size,
                                 void  *R34_10_1994_Q, int *Q_Size,
                                 void  *R34_10_1994_A
                                );
/**/
/*                  ⥭ ࠬ஢ ஢                         */
/*     樠஢ ⥪ ࠡ⪨/஢ન ஢     */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫    *P_Size  ⮣ 浪 P: *R34_10_1994_P.    */
/* - ⥫    *Q_Size  ⮣ 浪 Q: *R34_10_1994_Q.    */
/* - ⥫   ਬ⨢  㯯 A: *R34_10_1994_A.    */
/* 室:                                                                     */
/* -  R34_10_1994_P, R34_10_1994_Q  R34_10_1994_A ᮤঠ ࠬ     */
/*   P, Q  A, ᮮ⢥⢥.  *P_Size  Q_Size        */
/*   P  Q  .                                                          */
/* - ᫨ R34_10_1994_P == 0, ࠬ P  .                       */
/* - ᫨ R34_10_1994_Q == 0, ࠬ Q  .                       */
/* - ᫨ R34_10_1994_A == 0, ࠬ A  .                       */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_CONTEXTNOTREADY   - ⥪  樠஢.                     */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LR34_10_1994_gen_secret_key(struct LR34_10_1994 *Context);
int CrypC_LR34_10_2001_gen_secret_key(struct LR34_10_2001 *Context);
/**/
/*            ࠡ⪠  ⠭ 砩 ᥪ⭮                */
/*                   ⥪ ࠡ⪨ ஢                      */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* 室:                                                                     */
/* - ⥪, ⮢  ᫥ ஢ .                         */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_CONTEXTNOREADY    -  樠஢ ࠬ .           */
/* - RET_KEYALREADYPRESENT - 㦥 ⠭ ᥪ .                   */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LR34_10_1994_gen_public_key(struct LR34_10_1994 *Context);
int CrypC_LR34_10_2001_gen_public_key(struct LR34_10_2001 *Context);
/**/
/*                  ᫥  ⠭ ⮣                     */
/*                   ⥪ ࠡ⪨ ஢                      */
/*                     ⠭ ᥪ 箬                        */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* 室:                                                                     */
/* - ⥪, ⮢  ᫥  ஢થ ஢ .              */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_CONTEXTNOREADY    -  樠஢ ࠬ .           */
/* - RET_KEYALREADYPRESENT - 㦥 ⠭  .                    */
/* - RET_KEYNOTPRESENT     -  ⠭ ᥪ .                    */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LR34_10_1994_get_secret_key(struct LR34_10_1994 *Context, void *SecretKey, int *KeySize);
int CrypC_LR34_10_2001_get_secret_key(struct LR34_10_2001 *Context, void *SecretKey, int *KeySize);
/**/
/*       ⥭ ᥪ⭮   ⥪ ࠡ⪨ ஢       */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫   ᪨஢ ᥪ⭮ : *SecretKey.        */
/* - ⥫   ࠧ : *KeySize.                              */
/* 室:                                                                     */
/* - ᪨஢     SecretKey, ࠧ    */
/*   -   KeySize.                                                      */
/*   ᫨ SecretKey == 0,  頥 ⮫쪮  .                 */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_CONTEXTNOREADY    -  樠஢ ࠬ .           */
/* - RET_KEYNOTPRESENT     -  ⠭ ᥪ .                    */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LR34_10_1994_get_public_key(struct LR34_10_1994 *Context,          void *PublicKey, int *KeySize);
int CrypC_LR34_10_2001_get_public_key(struct LR34_10_2001 *Context, struct LPoint *PublicKey, int *KeySize);
/**/
/*       ⥭ ⮣   ⥪ ࠡ⪨ ஢        */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫   ⮣ : *PublicKey.                          */
/* - ⥫   ࠧ : *KeySize.                              */
/* 室:                                                                     */
/* -     PublicKey, ࠧ    -         */
/*   KeySize (ࠧ न 窨 ਢ   -  C3410).           */
/*   ᫨ PublicKey == 0,  頥 ⮫쪮  .                 */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_CONTEXTNOREADY    -  樠஢ ࠬ .           */
/* - RET_KEYNOTPRESENT     -  ⠭  .                     */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LR34_10_1994_set_secret_key(struct LR34_10_1994 *Context, void *SecretKey);
int CrypC_LR34_10_2001_set_secret_key(struct LR34_10_2001 *Context, void *SecretKey);
/**/
/*      ⠭ ᥪ⭮   ⥪ ࠡ⪨ ஢       */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫   ᪨஢ ᥪ⭮ : *SecretKey.        */
/* 室:                                                                     */
/* - ⥪, ⮢  ᫥ ஢ .                         */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_CONTEXTNOREADY    -  樠஢ ࠬ .           */
/* - RET_KEYALREADYPRESENT - 㦥 ⠭ ᥪ .                   */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LR34_10_1994_set_public_key(struct LR34_10_1994 *Context, void *PublicKey);
int CrypC_LR34_10_2001_set_public_key(struct LR34_10_2001 *Context, void *PublicKey);
/**/
/*      ⠭ ⮣   ⥪ ࠡ⪨ ஢        */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫   ⮣ : *PublicKey.                          */
/* 室:                                                                     */
/* - ⥪, ⮢  ஢થ ஢ .                           */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_CONTEXTNOREADY    -  樠஢ ࠬ .           */
/* - RET_KEYALREADYPRESENT - 㦥 ⠭  .                    */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LR34_10_1994_sign(struct LR34_10_1994 *Context, void *Digest, void *Signature);
int CrypC_LR34_10_2001_sign(struct LR34_10_2001 *Context, void *Digest, void *Signature);
/**/
/*           ࠡ⪠ ஢   -                 */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫   -: Digest (NQ*2 ).                      */
/* - ⥫    ஢ : Signature (4*NQ ).          */
/* 室:                                                                     */
/* -   ᮤন  । -.                      */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_CONTEXTNOREADY    -  樠஢ ࠬ .           */
/* - RET_KEYNOTPRESENT     -  ⠭ ᥪ .                    */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LR34_10_1994_verify(struct LR34_10_1994 *Context, void *Digest, void *Signature);
int CrypC_LR34_10_2001_verify(struct LR34_10_2001 *Context, void *Digest, void *Signature);
/**/
/*            ஢ઠ ஢   -                 */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫   -: Digest (NQ*2 ).                      */
/* - ⥫   ஢ : Signature (4*NQ ).              */
/* 室:                                                                     */
/* -  .                                                            */
/*  :                                                             */
/* - RET_OK             -  ஢७, १ ஢ન ⥫.*/
/* - RET_INCORRECTSIGN  -  ஢७, १ ஢ન ⥫.*/
/* - RET_ZERO_R         - 㫥 祭   r'.                 */
/* - RET_ZERO_S         - 㫥 祭   s .                 */
/* - RET_BAD_R          - ४⭮ 祭   r'.            */
/* - RET_BAD_S          - ४⭮ 祭   s .            */
/* - RET_CONTEXTNOTREADY   -  樠஢ ࠬ .           */
/* - RET_KEYNOTPRESENT     -  ⠭  .                     */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LR34_10_1994_clear_secret_key(struct LR34_10_1994 *Context);
int CrypC_LR34_10_2001_clear_secret_key(struct LR34_10_2001 *Context);
/**/
/*                  ⪠ ᥪ⭮   ⥪                      */
/*                  ࠡ⪨/஢ન ஢                        */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* 室:                                                                     */
/* - 饭  ᥪ⭮   ⥪.                            */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LR34_10_1994_clear_public_key(struct LR34_10_1994 *Context);
int CrypC_LR34_10_2001_clear_public_key(struct LR34_10_2001 *Context);
/**/
/*                  ⪠ ⮣   ⥪                       */
/*                  ࠡ⪨/஢ન ஢                        */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* 室:                                                                     */
/* - 饭  ⮣   ⥪.                             */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LR34_10_1994_clear(struct LR34_10_1994 *Context);
int CrypC_LR34_10_2001_clear(struct LR34_10_2001 *Context);
/**/
/*                           ⪠ ⥪                                */
/*                  ࠡ⪨/஢ન ஢                        */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* 室:                                                                     */
/* - 饭  ⥪.                                               */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_INCORRECTCONTEXT  - । 樠஢ ⥪ . ०.  */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LR34_10_2001_gen_mutual_key(struct LR34_10_2001 *Context,
                                       struct LPoint *PublicKey,
				       struct LPoint *MutualKey);
/**/
/*               ᫥ ᮢ⭮   ⮢                  */
/*       ᯮ짮 ᪠୮ 㬭  ᪮ ਢ,        */
/*            ᠭ  ⥪ ࠡ⪨ ஢                 */
/*                             3410-2001                                 */
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫   ⮣  PublicKey 㤠񭭮 .        */
/* - ⥫   ᮢ⭮  MutualKey.                          */
/* 室:                                                                     */
/* -    ஫ MutualKey.                                        */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_INCORRECTCONTEXT  - । 樠஢ ⥪ . ०.  */
/* - RET_CONTEXTNOREADY    -  樠஢ ࠬ .           */
/* - RET_KEYNOTPRESENT     -  ⠭ ᥪ .                    */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

/**/
/*Diffie/Hellman..............................................................*/
/**/
/**/
/*᫥ ᮢ 祩 ⮢......................................*/
/**/

int CrypC_LDH_PKA_set_parms(struct LDH_PKA *Context,
                            struct RND_State  *State, 
                            void  *DH_PKA_P, int P_Size,
                            void  *DH_PKA_A
                           );
/**/
/*          ⠭ ࠬ஢  ᫥ ᮢ 祩              */
/*                   ⥪ ० Diffie/Hellman                         */
/*                     ("樠" ⥪)                            */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫    P_Size ⮣ 浪   P: *DH_PKA_P.         */
/* - ⥫   ਬ⨢  㯯 A: *DH_PKA_A.         */
/*   ᫨ - 㪠⥫ ࠢ 0,   ࠬ  㬮砭    */
/*     P_Size  ⠢ 䫠 ⮢ ⥪. ⠫     */
/*   ࠬ .                                                  */
/* 室:                                                                     */
/* - ⥪, ⮢  ⠭ ᥪ⭮ / ⮣  .  */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_CONTEXTNOTCLEAR   - ⥪ 樠஢ ࠭.                  */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LDH_PKA_get_parms(struct LDH_PKA *Context,
                            void  *DH_PKA_P, int *P_Size,
                            void  *DH_PKA_A
                           );
/**/
/*                  ⥭ ࠬ஢ ஢                         */
/*     樠஢ ⥪ ࠡ⪨/஢ન ஢     */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫    *P_Size  ⮣ 浪 P: *DH_PKA_P.         */
/* - ⥫   ਬ⨢  㯯 A: *DH_PKA_A.         */
/* 室:                                                                     */
/* -  DH_PKA_P, DH_PKA_A ᮤঠ ࠬ P  A, ᮮ⢥⢥.        */
/*    *P_Size   P  .                              */
/* - ᫨ DH_PKA_P == 0, ࠬ P  .                            */
/* - ᫨ DH_PKA_A == 0, ࠬ A  .                            */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_CONTEXTNOTREADY   - ⥪  樠஢.                     */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LDH_PKA_gen_secret_key(struct LDH_PKA *Context);
/**/
/*            ࠡ⪠  ⠭ 砩 ᥪ⭮                */
/*                  ⥪ ᫥ ᮢ 祩                    */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* 室:                                                                     */
/* - ⥪  ⠭ 砩 ᥪ 箬.                     */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_CONTEXTNOREADY    -  樠஢ ࠬ .           */
/* - RET_KEYALREADYPRESENT - 㦥 ⠭ ᥪ .                   */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LDH_PKA_gen_public_key(struct LDH_PKA *Context);
/**/
/*                  ᫥  ⠭ ⮣                     */
/*                  ⥪ ᫥  ᮢ 祩                   */
/*                     ⠭ ᥪ 箬                        */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* 室:                                                                     */
/* - ⥪  ⠭  箬.                                */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_CONTEXTNOREADY    -  樠஢ ࠬ .           */
/* - RET_KEYALREADYPRESENT - 㦥 ⠭  .                    */
/* - RET_KEYNOTPRESENT     -  ⠭ ᥪ .                    */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LDH_PKA_gen_mutual_key(struct LDH_PKA *Context, void *PublicKey, void *MutualKey);
/**/
/*               ᫥ ᮢ⭮   ⮢                  */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫   ⮣ : *PublicKey (NP ᫮).                */
/* - ⥫   ᮢ⭮ : *MutualKey (NP ᫮).              */
/* 室:                                                                     */
/* -  , ᫥  ᥪ⭮  ⥪  ⮬   */
/*    PublicKey, 頥   MutualKey.                           */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_CONTEXTNOREADY    -  樠஢ ࠬ .           */
/* - RET_KEYNOTPRESENT     -  ⠭ ᥪ .                    */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LDH_PKA_get_secret_key(struct LDH_PKA *Context, void *SecretKey, int *KeySize);
/**/
/*      ⥭ ᥪ⭮   ⥪ ᫥ ᮢ 祩     */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫   ᪨஢ ᥪ⭮ : *SecretKey.        */
/* - ⥫   ࠧ : *KeySize.                              */
/* 室:                                                                     */
/* - ᪨஢     SecretKey, ࠧ    */
/*   -   KeySize.                                                      */
/*   ᫨ SecretKey == 0,  頥 ⮫쪮  .                 */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_CONTEXTNOREADY    -  樠஢ ࠬ .           */
/* - RET_KEYNOTPRESENT     -  ⠭ ᥪ .                    */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LDH_PKA_get_public_key(struct LDH_PKA *Context, void *PublicKey, int *KeySize);
/**/
/*      ⥭ ⮣   ⥪ ᫥ ᮢ 祩      */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫   ⮣ : *PublicKey.                          */
/* - ⥫   ࠧ : *KeySize.                              */
/* 室:                                                                     */
/* -     PublicKey, ࠧ    -         */
/*   KeySize.                                                                 */
/*   ᫨ PublicKey == 0,  頥 ⮫쪮  .                 */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_CONTEXTNOREADY    -  樠஢ ࠬ .           */
/* - RET_KEYNOTPRESENT     -  ⠭  .                     */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LDH_PKA_set_secret_key(struct LDH_PKA *Context, void *SecretKey);
/**/
/*     ⠭ ᥪ⭮   ⥪ ᫥ ᮢ 祩     */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* - ⥫   ᪨஢ ᥪ⭮ : *SecretKey.        */
/* 室:                                                                     */
/* - ⥪  ⠭ ᥪ 箬.                               */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_CONTEXTNOREADY    -  樠஢ ࠬ .           */
/* - RET_KEYALREADYPRESENT - 㦥 ⠭ ᥪ .                   */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LDH_PKA_clear_secret_key(struct LDH_PKA *Context);
/**/
/*                  ⪠ ᥪ⭮   ⥪                      */
/*                     ᫥ ᮢ 祩                           */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* 室:                                                                     */
/* - 饭  ᥪ⭮   ⥪.                            */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LDH_PKA_clear_public_key(struct LDH_PKA *Context);
/**/
/*                  ⪠ ⮣   ⥪                       */
/*                     ᫥ ᮢ 祩                           */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* 室:                                                                     */
/* - 饭  ⮣   ⥪.                             */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

int CrypC_LDH_PKA_clear(struct LDH_PKA *Context);
/**/
/*                           ⪠ ⥪                                */
/*                     ᫥ ᮢ 祩                           */
/**/
/* 室 ࠬ:                                                         */
/* - ⥫   ⥪: *Context ().                      */
/* 室:                                                                     */
/* - 饭  ⥪.                                               */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_INCORRECTCONTEXT  - । 樠஢ ⥪ . ०.  */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

/**/
/*㭪.樨.砩.᫥⥫쭮⥩.............................*/
/**/

int CrypC_Random_Fill( struct RND_State *State, void  *Field, int Bytes );
/**/
/*                   ᥢ砩묨 묨.                */
/**/
/* 室 ࠬ:                                                         */
/* -    Field.                                               */
/* -     Bytes.                                            */
/* 室:                                                                     */
/* -   ᥢ砩 ᫥⥫쭮   Bytes.     */
/*  :                                                             */
/* - RET_OK                - ଠ쭮 襭.                           */
/* - RET_INVALIDPARAMETER  - 㫥 㪠⥫  易⥫ ࠬ.      */
/**/

/**/
/*㭪樨.஢ન.楤...............................................*/
/**/
/**/
/*஢ઠ 㭪権 ஢  ࠡ⪨ .................................*/
/**/

int CrypC_TestCryptoFunctions_( void );
/**/
/*                㭪 ஢ન ਯ⮣᪨ 楤                 */
/**/
/* 믮 ᫥⥫쭮 ஢ ⢨  ⢥ ᯮ짮- */
/*   짮⥫᪨ 㭪権, ⭮  ⥣ਨ 㭪権 - */
/* ஢.                                                                   */
/* -  :                                                            */
/*   0 - १ ஢ન ⥫.                                    */
/*   1 - १ ஢ન ⥫.                                    */
/**/

int CrypC_TestSignFunctions_( int Size );
/**/
/*                㭪 ஢ન 楤 ஢                   */
/**/
/* 믮 ᫥⥫쭮 ஢ ⢨  ⢥ ᯮ짮- */
/*   짮⥫᪨ 㭪権, ⭮  ⥣ਨ 㭪権 -  */
/* ᫥/஢ન ஢   ࠡ⪨ ᮢ 祩 裡.    */
/* -  :                                                            */
/*   0 - १ ஢ન ⥫.                                    */
/*   1 - १ ஢ન ⥫.                                    */
/**/

/******************************************END*/
