/*******************************************************************************
  Proj: libosr (Optical Symbols Recognition library)
  --------------------------------------------------------------------------- 
  File: osr_common.h
  Created: 2006/09/08
  Desc: common types, defines, includes for OSR sources
  --------------------------------------------------------------------------- 
  Evgeny P. Smirnov, Evgeny.Smirnov@kaspersky.com
********************************************************************************/
//--------------------------------------------------------------------------------------------------------------------//
#ifndef __osr_common_h__
#define __osr_common_h__
//--------------------------------------------------------------------------------------------------------------------//
#include <stdlib.h>
#include "osr_error.h"
//--------------------------------------------------------------------------------------------------------------------//
#ifdef _MSC_VER
# pragma warning( disable : 4514 4505 4710) 
#endif // _MSC_VER
//--------------------------------------------------------------------------------------------------------------------//
#ifdef __cplusplus
extern "C"
{
#endif // __cplusplus
//--------------------------------------------------------------------------------------------------------------------//
namespace OSR
{
//--------------------------------------------------------------------------------------------------------------------//
#define MAX_OSRIMAGE_WIDTH  1500
#define MAX_OSRIMAGE_HEIGHT 1500
#define MIN_OSRIMAGE_WIDTH  5
#define MIN_OSRIMAGE_HEIGHT 5

enum Color {BLACK, WHITE};

#define GSG7_SIGNATURE_LENGHT   33
typedef char GSG7Signature[GSG7_SIGNATURE_LENGHT];

typedef short Size;

struct RGB
{
    unsigned char R, G, B;
};

} // namespace OSR
//--------------------------------------------------------------------------------------------------------------------//
#ifdef __cplusplus
}
#endif
//--------------------------------------------------------------------------------------------------------------------//
#endif // __osr_common_h__
//--------------------------------------------------------------------------------------------------------------------//
