/*******************************************************************************
  Proj: libosr (Optical Symbols Recognition library)
  --------------------------------------------------------------------------- 
  File: osr_error.h
  Created: 2006/09/08
  Desc: error codes and its texts
  --------------------------------------------------------------------------- 
  Evgeny P. Smirnov, Evgeny.Smirnov@kaspersky.com
********************************************************************************/
/*--------------------------------------------------------------------------------------------------------------------*/
#ifndef __osr_error_h__
#define __osr_error_h__
/*--------------------------------------------------------------------------------------------------------------------*/
#ifdef __cplusplus
extern "C"
{
#endif
/*--------------------------------------------------------------------------------------------------------------------*/
enum ErrCode
{
    OSR_OK                  = 0,
    OSR_INVALID_ARGUMENT    = 1,
    OSR_INVALID_DATA        = 2,
    OSR_INTERNAL_ERROR      = 3, // logic error
    OSR_MEMORY_FULL         = 4,
    OSR_REJECTION           = 5,
    OSR_IMAGE_TOO_SMALL     = 6,
    OSR_IMAGE_TOO_LARGE     = 7,
    OSR_FILE_ERROR          = 8,
    OSR_FILE_TOO_LARGE      = 9,
    OSR_IMAGE_FORMAT_ERROR  = 10,
    OSR_WRONG_FRAME_INDEX   = 11,
    OSR_ERROR               = 255
};

typedef enum ErrCode osr_err_code;

const char* ErrorText (const enum ErrCode err);
/*--------------------------------------------------------------------------------------------------------------------*/
#ifdef __cplusplus
}
#endif
/*--------------------------------------------------------------------------------------------------------------------*/
#endif /*__osr_error_h__*/
/*--------------------------------------------------------------------------------------------------------------------*/
