/*-----------------02.05.99 12:57-------------------
 * Project Prague                                 *
 * Subproject Message properties definition       *
 * Author Mezhuev Pavel                           *
 * Copyright (c) Kaspersky Lab                    *
 * Purpose Prague API                             *
 *                                                *
--------------------------------------------------*/

#ifndef __PR_MAILMSG_PROPS_H
#define __PR_MAILMSG_PROPS_H

/* creation type flags */

#define fOMODE_CREATE_PLAIN_BODY	((tDWORD)(0x10000000L))
#define fOMODE_CREATE_RICH_BODY		((tDWORD)(0x20000000L))
#define fOMODE_CREATE_HTML_BODY		((tDWORD)(0x40000000L))
#define fOMODE_CREATE_ATTACH		((tDWORD)(0x80000000L))

/* global Mail Message properties */

#define pgMESSAGE_FROM						mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x00001000 )
#define pgMESSAGE_ORIGINAL_FROM				mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x00001001 )
#define pgMESSAGE_DISPLAY_FROM				mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x00001002 )
#define pgMESSAGE_ORIGINAL_DISPLAY_FROM		mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x00001003 )
#define pgMESSAGE_TO						mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x00001004 )
#define pgMESSAGE_DISPLAY_TO				mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x00001005 )
#define pgMESSAGE_CC						mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x00001006 )
#define pgMESSAGE_DISPLAY_CC				mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x00001007 )
#define pgMESSAGE_SUBJECT					mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x00001008 )
#define pgMESSAGE_DATE						mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x00001009 )
#define pgMESSAGE_MAILID					mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x0000100a )
#define pgMESSAGE_INTERNET_HEADERS			mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x0000100b )
#define pgMESSAGE_MIME_VERSION				mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x0000100c )
#define pgMESSAGE_RETURN_PATH				mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x0000100d )
#define pgMESSAGE_FROM_SMTP					mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x0000100e )


/* global Mail Message Part properties */

#define pgMESSAGE_PART_CONTENT_TYPE			mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x00001020 )
#define pgMESSAGE_PART_TRANSFER_ENCODING	mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x00001021 )
#define pgMESSAGE_PART_FILE_NAME			mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x00001022 )
#define pgMESSAGE_PART_DISPLAY_NAME			mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x00001023 )
#define pgMESSAGE_PART_CONTENT_ID			mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x00001024 )
#define pgMESSAGE_PART_CONTENT_DESCRIPTION	mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x00001025 )
#define pgMESSAGE_PART_CHARSET				mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x00001026 )
#define pgMESSAGE_PART_CONTENT_LENGTH		mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x00001027 )

/* global Properties for work with custom mime properties */

#define pgMESSAGE_X_PROP_NAME				mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x00001030 )
#define pgMESSAGE_X_PROP_VALUE				mPROPERTY_MAKE_GLOBAL( pTYPE_STRING  , 0x00001031 )

/* mail object unique id */

#define pgMAIL_OBJECT_ENTRYID				mPROPERTY_MAKE_GLOBAL( pTYPE_BINARY , 0x00001040 )

/* mail folder properties */

#define pgIS_MESSAGE_STORAGE				mPROPERTY_MAKE_GLOBAL( pTYPE_BOOL   , 0x00001041 )
#define pgCAN_CREATE_SUBFOLDERS				mPROPERTY_MAKE_GLOBAL( pTYPE_BOOL   , 0x00001042 )
#define pgSUBFOLDERS_COUNT					mPROPERTY_MAKE_GLOBAL( pTYPE_DWORD  , 0x00001043 )
#define pgFOLDER_TYPE						mPROPERTY_MAKE_GLOBAL( pTYPE_DWORD  , 0x00001044 )

/* os types defines */

#define MAIL_OS_TYPE_SYSTEM				    0
#define MAIL_OS_TYPE_DBX				    1
#define MAIL_OS_TYPE_MIME				    2
#define MAIL_OS_TYPE_PST				    3
#define MAIL_OS_TYPE_OUTLOOK				4

#endif // __PR_MAILMSG_PROPS_H
