#ifndef __GKLLAPI_H__
#define __GKLLAPI_H__

#ifndef __FILTER_DRIVER_SOURCE__
#define FILTER_API _declspec(dllimport)
#endif

#ifdef __cplusplus
extern "C"  {
#endif

typedef NTSTATUS (*FILTER_COMPLETION_PROC)(PDEVICE_OBJECT, PIRP);
typedef NTSTATUS (*FILTER_DISPATCH_PROC)(PDEVICE_OBJECT, PIRP);
typedef NTSTATUS (*NOTIFICATION_PROC)();

typedef struct {
	FILTER_DISPATCH_PROC		Dispatch[IRP_MJ_MAXIMUM_FUNCTION+1];
	FILTER_COMPLETION_PROC		Complete[IRP_MJ_MAXIMUM_FUNCTION+1];
	NOTIFICATION_PROC			SettingsModified;
} LOWLEVEL_FILTER_CALLBACK, *PLOWLEVEL_FILTER_CALLBACK;


NTSTATUS FILTER_API LowlevelFilterRegister(PDRIVER_OBJECT, PLOWLEVEL_FILTER_CALLBACK, PPLUGIN_INFO, PULONG, ULONG, ULONG, PVOID *);


#ifdef __cplusplus
}
#endif

#endif __GKLLAPI_H__
